/***************************************************************************\
 * Micro DVD Menu Maker by Christophe.Paris@free.fr                        *
 ***************************************************************************
 *  This program is free software; you can redistribute it and/or modify   *
 *  it under the terms of the GNU General Public License as published by   *
 *  the Free Software Foundation; either version 2 of the License, or      *
 *  (at your option) any later version.                                    *
 *                                                                         *
 *  This program is distributed in the hope that it will be useful,        *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of         *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          *
 *  GNU General Public License for more details.                           *
\***************************************************************************/

//---------------------------------------------------------------------------

#ifndef MainH
#define MainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <Dialogs.hpp>
#include <Buttons.hpp>
#include <ComCtrls.hpp>
#include <Menus.hpp>
#include <Graphics.hpp>

#include "Page.h"
#include "RShape.h"
#include <ImgList.hpp>

extern TColor ColorOK;
extern TColor ColorNOK;

//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
class TMainForm : public TForm
{
__published:	// IDE-managed Components
	TOpenDialog *OpenDialog1;
	TMainMenu *MainMenu1;
	TMenuItem *File1;
	TMenuItem *miMMOpenINI;
	TMenuItem *miMMQuit;
	TMenuItem *N1;
	TMenuItem *miPage;
	TMenuItem *MenuItemNewPage;
	TMenuItem *MenuItemDeletePage;
	TMenuItem *MenuItemModifyNamePage;
	TMenuItem *MenuItemFirstFramePage;
	TMenuItem *MenuItemLastFramePage;
	TMenuItem *N2;
	TMenuItem *N3;
	TMenuItem *miMMSaveasINI;
	TPopupMenu *ShapePopUp;
	TMenuItem *Delete1;
	TMenuItem *N4;
	TMenuItem *miAbout;
	TMenuItem *Windows1;
	TMenuItem *Pages1;
	TMenuItem *SelectionsWindow1;
	TMenuItem *miWinPagesLeft;
	TMenuItem *miWinPagesRight;
	TMenuItem *miWinSelecLeft;
	TMenuItem *miWinSelecRight;
	TMenuItem *Movetopage1;
	TMenuItem *miWinPagesFree;
	TMenuItem *miWinSelecFree;
	TSaveDialog *SaveDialog1;
	TMenuItem *miMovieData;
	TMenuItem *miNew;
	TMenuItem *miMMSaveINI;
	TPanel *MainPanel;
	TPageControl *DockPageControl;
	TPanel *VideoPanel;
	TBevel *VideoBevel;
	TImage *VideoImage;
	TShape *HLine1;
	TShape *HLine2;
	TShape *VLine1;
	TShape *VLine2;
	TTrackBar *VideoTrackBar;
	TPanel *ControlPanel;
	TSpeedButton *bttStart;
	TSpeedButton *bttPrevFrame;
	TSpeedButton *bttNextFrame;
	TSpeedButton *bttEnd;
	TSpeedButton *bttPrevKF;
	TSpeedButton *bttNextKF;
	TSpeedButton *bttGoto;
	TPanel *FrameInfoPanel;
	TEdit *edVideoPos;
	TSplitter *Splitter1;
	TMenuItem *miDocked;
	TMenuItem *N5;
	TMenuItem *miGotoNextPage;
	TMenuItem *miGotoPreviousPage;
	void __fastcall miMMQuitClick(TObject *Sender);
	void __fastcall FormDestroy(TObject *Sender);
	void __fastcall VideoTrackBarChange(TObject *Sender);
	void __fastcall bttNextFrameClick(TObject *Sender);
	void __fastcall bttPrevFrameClick(TObject *Sender);
	void __fastcall bttEndClick(TObject *Sender);
	void __fastcall bttStartClick(TObject *Sender);
	void __fastcall bttNextKFClick(TObject *Sender);
	void __fastcall bttPrevKFClick(TObject *Sender);
	void __fastcall MenuItemNewPageClick(TObject *Sender);
	void __fastcall MenuItemDeletePageClick(TObject *Sender);
	void __fastcall MenuItemModifyNamePageClick(TObject *Sender);
	void __fastcall VideoImageMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
	void __fastcall VideoImageMouseUp(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
	void __fastcall VideoImageMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
	void __fastcall MenuItemFirstFramePageClick(TObject *Sender);
	void __fastcall MenuItemLastFramePageClick(TObject *Sender);
	void __fastcall bttGotoClick(TObject *Sender);
	void __fastcall edVideoPosExit(TObject *Sender);
	void __fastcall edVideoPosEnter(TObject *Sender);

	void __fastcall ShapeContextPopup(TObject *Sender, const TPoint &MousePos,
          bool &Handled);
	void __fastcall ShapeMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
	void __fastcall ShapeMouseUp(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
	void __fastcall ShapeMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);

	void __fastcall Delete1Click(TObject *Sender);
	void __fastcall RadioMenuItemCheck(TObject *Sender);
	void __fastcall miMMOpenINIClick(TObject *Sender);
	void __fastcall miMMSaveasINIClick(TObject *Sender);
	void __fastcall miMovieDataClick(TObject *Sender);
	void __fastcall miNewClick(TObject *Sender);
	void __fastcall miMMSaveINIClick(TObject *Sender);
	void __fastcall miAboutClick(TObject *Sender);
	void __fastcall OnChangePageSelectionClick(TObject* Sender);
	void __fastcall DockPageControlDockDrop(TObject *Sender,
          TDragDockObject *Source, int X, int Y);
	void __fastcall DockPageControlUnDock(TObject *Sender, TControl *Client,
          TWinControl *NewTarget, bool &Allow);
	void __fastcall miDockedClick(TObject *Sender);
	void __fastcall miGotoNextPageClick(TObject *Sender);
	void __fastcall miGotoPreviousPageClick(TObject *Sender);
protected:
		void __fastcall OnMainFormMove(TMessage &Message);
BEGIN_MESSAGE_MAP
	MESSAGE_HANDLER(WM_MOVE, TMessage, OnMainFormMove)
END_MESSAGE_MAP(TForm)


private:	// User declarations
	void __fastcall SaveOptions(void);
	void __fastcall LoadOptions(void);
public:		// User declarations
	__fastcall TMainForm(TComponent* Owner);

	AnsiString CurrentFileName;
	void __fastcall OpenAVI(AnsiString filename);
	void __fastcall ResizeVideoImage(int width, int height);
	void __fastcall ChangeCurrentSelectedShape(RShape* r);
	void __fastcall OnCurrentSelectionChangedSize(void);
	void __fastcall ShowCrossCursor(bool show);
	void __fastcall OnAnyAnchorMoveHideCrossCursor(void);
	void __fastcall OnNewPageReadInINIFile(Page *p);
	void __fastcall OnNewSelectionReadInINIFile(Selection *s, Page* parentPage);
	AnsiString __fastcall GetCurrentShapeXYXYCoordinate(void);
	void __fastcall ShowMessageMissINIKey(AnsiString as);
	void __fastcall SaveINI(bool ForceSaveAs);
	void __fastcall UpdateCaption();
	void __fastcall AddIfParamNotEmpty(TStringList* fINI, AnsiString key,
		AnsiString param);
	// int __fastcall CalculateChapterMax();		
};
//---------------------------------------------------------------------------
extern PACKAGE TMainForm *MainForm;
extern RShape *shapeModel;
extern RShape *currentShape;
//---------------------------------------------------------------------------
#endif

