/***************************************************************************\
 * Micro DVD Menu Maker by Christophe.Paris@free.fr                        *
 ***************************************************************************
 *  This program is free software; you can redistribute it and/or modify   *
 *  it under the terms of the GNU General Public License as published by   *
 *  the Free Software Foundation; either version 2 of the License, or      *
 *  (at your option) any later version.                                    *
 *                                                                         *
 *  This program is distributed in the hope that it will be useful,        *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of         *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          *
 *  GNU General Public License for more details.                           *
\***************************************************************************/

//---------------------------------------------------------------------------
#ifndef PageViewerH
#define PageViewerH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Buttons.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <Jpeg.hpp>
#include <Menus.hpp>
#include <ImgList.hpp>
//---------------------------------------------------------------------------
class TPageViewerForm : public TForm
{
__published:	// IDE-managed Components
	TListBox *PageList;
	TPanel *plBottControl;
	TGroupBox *gbOptions;
	TLabel *Label3;
	TLabel *Label1;
	TLabel *lbPicture;
	TSpeedButton *bttBrowsePicture;
	TLabel *lbRange;
	TLabel *lbJumpAtEnd;
	TLabel *lbPictureDuration;
	TLabel *lbActionAtEnd;
	TLabel *lbDefaultSel;
	TLabel *lbPSB;
	TLabel *lbSelOrder;
	TSpeedButton *bttShowAdvancedOpt;
	TCheckBox *chkVideoLoop;
	TCheckBox *chkSelectionAvailable;
	TEdit *edPageName;
	TRadioButton *rbVideo;
	TRadioButton *rbStillImage;
	TEdit *edPictureFileName;
	TEdit *edRange;
	TEdit *edPictureDuration;
	TComboBox *cbJumpAtEnd;
	TEdit *edProhibitSelBefore;
	TEdit *edProhibitSelAfter;
	TPanel *bttToolBarPanel;
	TSpeedButton *bttAdd;
	TSpeedButton *bttDel;
	TSpeedButton *bttModify;
	TSpeedButton *bttFirst;
	TSpeedButton *bttLast;
	TComboBox *cbDefaultSelection;
	TPopupMenu *puPageList;
	TMenuItem *puPLDelete;
	TMenuItem *puPLUp;
	TMenuItem *puPLDown;
	TMenuItem *N1;
	TLabel *lbNumber;
	TEdit *edNumber;
	TListBox *lstActionAtEnd;
	TMenuItem *N2;
	TMenuItem *puPLCopySelections;
	TMenuItem *puPLPasteSelections;
	TMenuItem *N3;
	TMenuItem *SetasStartPage1;
	TMenuItem *SetasMenuPage1;
	TMenuItem *SetasChaptersPage1;
	TMenuItem *SetasSpecialsPage1;
	TPanel *Panel1;
	TRadioButton *rbRow;
	TRadioButton *rbColumn;
	TImageList *ImageList1;
	TPopupMenu *puActionAtEnd;
	TMenuItem *miDeleteActionAtEnd;
	TMenuItem *miSetActionAtEnd;
	void __fastcall PageListDrawItem(TWinControl *Control, int Index,
          TRect &Rect, TOwnerDrawState State);
	void __fastcall bttAddClick(TObject *Sender);
	void __fastcall bttDelClick(TObject *Sender);
	void __fastcall bttFirstClick(TObject *Sender);
	void __fastcall bttLastClick(TObject *Sender);
	void __fastcall PageListClick(TObject *Sender);
	void __fastcall bttModifyClick(TObject *Sender);
	void __fastcall bttShowAdvancedOptClick(TObject *Sender);
	void __fastcall rbVideoClick(TObject *Sender);
	void __fastcall bttBrowsePictureClick(TObject *Sender);
	void __fastcall FormDestroy(TObject *Sender);
	void __fastcall chkVideoLoopClick(TObject *Sender);
	void __fastcall puPLDeleteClick(TObject *Sender);
	void __fastcall puPLUpDownClick(TObject *Sender);
	void __fastcall cbJumpAtEndDrawItem(TWinControl *Control, int Index,
          TRect &Rect, TOwnerDrawState State);
	void __fastcall lstActionAtEndDragOver(TObject *Sender, TObject *Source,
          int X, int Y, TDragState State, bool &Accept);
	void __fastcall lstActionAtEndDragDrop(TObject *Sender, TObject *Source,
          int X, int Y);
	void __fastcall lstActionAtEndDrawItem(TWinControl *Control, int Index,
          TRect &Rect, TOwnerDrawState State);
	void __fastcall chkSelectionAvailableClick(TObject *Sender);
	void __fastcall PageListDragOver(TObject *Sender, TObject *Source, int X,
          int Y, TDragState State, bool &Accept);

	void __fastcall ShowPage(int index);
	void __fastcall ShowPage(int index, bool ShowFirstFrame);
	void __fastcall DeletePage(int index);
	void __fastcall PageListContextPopup(TObject *Sender, TPoint &MousePos,
          bool &Handled);
	void __fastcall puPLCopySelectionsClick(TObject *Sender);
	void __fastcall puPLPasteSelectionsClick(TObject *Sender);
	void __fastcall SetasStartPage1Click(TObject *Sender);
	void __fastcall SetasMenuPage1Click(TObject *Sender);
	void __fastcall SetasChaptersPage1Click(TObject *Sender);
	void __fastcall SetasSpecialsPage1Click(TObject *Sender);
	void __fastcall lstActionAtEndKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
	void __fastcall UpdateDefaultSelectionCombo(Page* p);
	void __fastcall lstActionAtEndDblClick(TObject *Sender);
	void __fastcall miSetActionAtEndClick(TObject *Sender);
	void __fastcall miDeleteActionAtEndClick(TObject *Sender);
private:	// User declarations
	int ClipboardPageIndex;

public:		// User declarations
	int previousPageIndex;
	int currentPageIndex;
	void __fastcall ReInit();
	__fastcall TPageViewerForm(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TPageViewerForm *PageViewerForm;
//---------------------------------------------------------------------------
#endif
